
// ==========================================
//
// F6FBB 09/97 Portage DxNet F5MZN sous LINUX
//
// ==========================================


#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <stdio.h>
#include "define.h"
extern "C"
{
#include "memory.h"
void far XMSCALL(byte NumFonc, unsigned int offset, unsigned int segment);
}

void far *XMSPTR;
byte XMSErr;

static long usedXMS;
static long usedConv;

/* ---------------------------------------------------------------------
   XMSQueryVer: Renvoie le no de version de l'XMS et autres informations
		sur l'etat
   ---------------------------------------------------------------------*/
static int XMSQueryVer( int * VerNr, int * RevNr)
{
	XMSRegs Xr;
	XMSCALL(0, FP_OFF(&Xr), FP_SEG(&Xr));
	*VerNr = Hi(Xr.AX) * 100 + ( Lo(Xr.AX) >> 4 ) * 10 + ( Lo(Xr.AX) & 15 );
	*RevNr = Hi(Xr.BX) * 100 + ( Lo(Xr.BX) >> 4 ) * 10 + ( Lo(Xr.BX) & 15 );
	return( Xr.DX == 1 );
}

/* XMSGetMem : Alloue un bloc de memoire etendue */
static int XMSGetMem( int LenKb )
{
	XMSRegs Xr;

	Xr.DX = LenKb;
	XMSCALL(9, FP_OFF(&Xr), FP_SEG(&Xr));
	return Xr.DX;
}

/* XMSFreeMem : Libere un bloc de memoire XMS */
void XMSFreeMem(int Handle)
{
	XMSRegs Xr;
	Xr.DX = Handle;
	XMSCALL(10, FP_OFF(&Xr), FP_SEG(&Xr));
}

static void XMSCopy(int HandleOrig, long OffsetOrig, int HandleDest, long OffsetDest, int length)
{
	XMSRegs Xr;
	EMMS Mi;
	void far * MiPtr;

	Mi.LenB    = length;
	Mi.SHandle = HandleOrig;
	Mi.SOffset = OffsetOrig;
	Mi.DHandle = HandleDest;
	Mi.DOffset = OffsetDest;

	MiPtr      = &Mi;
	Xr.SI      = FP_OFF(MiPtr);
	Xr.Segment = FP_SEG(MiPtr);
	XMSCALL(11, FP_OFF(&Xr), FP_SEG(&Xr));
}

int xinit(void)
{
	union REGS Regs;
	struct SREGS SRegs;
	XMSRegs Xr;

	Regs.x.ax = 0x4300;
	int86(0x2F, &Regs, &Regs);
	if( Regs.h.al == 0x80 )
	{
		Regs.x.ax = 0x4310;
		int86x(0x2F, &Regs, &Regs, &SRegs);
		XMSPTR = MK_FP(SRegs.es, Regs.x.bx);
		XMSErr = ERR_NOERR;
		return TRUE;
	}
	else
		return FALSE;
}

mem_hand xalloc (unsigned linesize, unsigned nlines)
{
	if( linesize % 2 )
		linesize++;
	int blocsize = linesize * nlines;
	int kbytes = blocsize / 1024 + 1;
	mem_hand mh = (mem_hand) malloc(sizeof (struct memh));

	if( mh != NULL )
	{
		mh->XMShandle = XMSGetMem(kbytes);
		mh->linesize = linesize;
		mh->nlines = nlines;
		mh->ptr = (byte *) malloc(linesize);
	}

	if( mh == NULL || mh->XMShandle == 0 || mh->ptr == NULL )
	{
		printf("fatal error in xalloc : not enough memory to continue\n");
		exit(0);
	}

	usedXMS  += kbytes;
	usedConv += sizeof(struct memh) + linesize;
	return mh;
}

void xfree(mem_hand mh)
{
	int kbytes = (mh->linesize + mh->nlines) / 1024 + 1;
	usedXMS  -= kbytes;
	usedConv -= sizeof(struct memh) + mh->linesize;
	free(mh->ptr);
	XMSFreeMem(mh->XMShandle);
	free(mh);
}

int xput(byte * src, unsigned line, mem_hand mh)
{
	if (line >= mh->nlines)
		return 0;
	XMSCopy(0, (long) ((void far *) src), mh->XMShandle,
		(long) line * mh->linesize, mh->linesize);
	return 1;
}

byte *xget(unsigned line, mem_hand mh)
{
	if (line >= mh->nlines)
		return mh->ptr;
	XMSCopy(mh->XMShandle, (long) (line * mh->linesize), 0,
		(long) ((void far *) mh->ptr), mh->linesize);
	return mh->ptr;
}

int setXMstrat (char *)
{
	return 1;
}

void SetReadMode (mem_hand, int)
{
}

char *mem_type (mem_hand)
{
	return ("XMS");
}

void xmemuse(long* xms, long* conv)
{
	*xms  = usedXMS * 1024L;
	*conv = usedConv;
}
